#![allow(deprecated)]

pub mod map_coords {
    mod modern {
        pub(crate) use geo_types::geometry::{Coordinate, Geometry, GeometryCollection, Triangle};
        pub(crate) use geo_types::CoordNum;
        pub trait MapCoordsInPlace<T> {
            fn map_coords_in_place(&mut self, func: impl Fn(Coordinate<T>) -> Coordinate<T> + Copy)
            where
                T: CoordNum;
            fn try_map_coords_in_place<E>(
                &mut self,
                func: impl Fn(Coordinate<T>) -> Result<Coordinate<T>, E>,
            ) -> Result<(), E>
            where
                T: CoordNum;
        }
        impl<T: CoordNum> MapCoordsInPlace<T> for Geometry<T> {
            #[inline(never)]
            fn map_coords_in_place(
                &mut self,
                _func: impl Fn(Coordinate<T>) -> Coordinate<T> + Copy,
            ) {
                todo!();
            }
            #[inline(never)]
            fn try_map_coords_in_place<E>(
                &mut self,
                func: impl Fn(Coordinate<T>) -> Result<Coordinate<T>, E>,
            ) -> Result<(), E> {
                match *self {
                    Geometry::Point(ref mut _x) => {
                        todo!()
                    }
                    Geometry::Line(ref mut _x) => {
                        todo!()
                    }
                    Geometry::LineString(ref mut _x) => {
                        todo!()
                    }
                    Geometry::Polygon(ref mut _x) => {
                        todo!()
                    }
                    Geometry::MultiPoint(ref mut _x) => {
                        todo!()
                    }
                    Geometry::MultiLineString(ref mut _x) => {
                        todo!()
                    }
                    Geometry::MultiPolygon(ref mut _x) => {
                        todo!()
                    }
                    Geometry::GeometryCollection(ref mut x) => x.try_map_coords_in_place(func),
                    Geometry::Rect(ref mut _x) => todo!(),
                    Geometry::Triangle(ref mut x) => x.try_map_coords_in_place(func),
                }
            }
        }
        impl<T: CoordNum> MapCoordsInPlace<T> for GeometryCollection<T> {
            #[inline(never)]
            fn map_coords_in_place(
                &mut self,
                _func: impl Fn(Coordinate<T>) -> Coordinate<T> + Copy,
            ) {
                todo!();
            }
            #[inline(always)]
            fn try_map_coords_in_place<E>(
                &mut self,
                func: impl Fn(Coordinate<T>) -> Result<Coordinate<T>, E>,
            ) -> Result<(), E> {
                for p in &mut self.0 {
                    p.try_map_coords_in_place(&func)?;
                }
                Ok(())
            }
        }
        impl<T: CoordNum> MapCoordsInPlace<T> for Triangle<T> {
            #[inline(never)]
            fn map_coords_in_place(&mut self, _func: impl Fn(Coordinate<T>) -> Coordinate<T>) {
                todo!();
            }
            #[inline(never)]
            fn try_map_coords_in_place<E>(
                &mut self,
                func: impl Fn(Coordinate<T>) -> Result<Coordinate<T>, E>,
            ) -> Result<(), E> {
                func(self.0)?;
                todo!();
            }
        }
    }
    pub(crate) mod deprecated {
        use super::modern::*;
        pub trait TryMapCoordsInplace<T, E> {
            fn try_map_coords_inplace(
                &mut self,
                func: impl Fn((T, T)) -> Result<(T, T), E>,
            ) -> Result<(), E>
            where
                T: CoordNum;
        }
        pub trait MapCoordsInplace<T>: MapCoordsInPlace<T> {
            fn map_coords_inplace(&mut self, func: impl Fn((T, T)) -> (T, T) + Copy)
            where
                T: CoordNum;
        }
        impl<T: CoordNum, E> TryMapCoordsInplace<T, E> for GeometryCollection<T> {
            #[inline(never)]
            fn try_map_coords_inplace(
                &mut self,
                func: impl Fn((T, T)) -> Result<(T, T), E>,
            ) -> Result<(), E> {
                MapCoordsInPlace::try_map_coords_in_place(self, |c| Ok(func(c.x_y())?.into()))
            }
        }
    }
}
